
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Quality_processesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quality_processes = await db.quality_processes.create(
            {
                id: data.id || undefined,
        
        process_type: data.process_type
        ||
        null
            ,
            
        headline: data.headline
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        profile_highlight: data.profile_highlight
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.quality_processes.getTableName(),
                belongsToColumn: 'diagram_images',
                belongsToId: quality_processes.id,
            },
            data.diagram_images,
            options,
        );
        

        return quality_processes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const quality_processesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                process_type: item.process_type
            ||
            null
            ,
            
                headline: item.headline
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                profile_highlight: item.profile_highlight
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const quality_processes = await db.quality_processes.bulkCreate(quality_processesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < quality_processes.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.quality_processes.getTableName(),
                    belongsToColumn: 'diagram_images',
                    belongsToId: quality_processes[i].id,
                },
                data[i].diagram_images,
                options,
            );
        }
        

        return quality_processes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const quality_processes = await db.quality_processes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.process_type !== undefined) updatePayload.process_type = data.process_type;
        
        
        if (data.headline !== undefined) updatePayload.headline = data.headline;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.profile_highlight !== undefined) updatePayload.profile_highlight = data.profile_highlight;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await quality_processes.update(updatePayload, {transaction});

        
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.quality_processes.getTableName(),
                belongsToColumn: 'diagram_images',
                belongsToId: quality_processes.id,
            },
            data.diagram_images,
            options,
        );
        

        return quality_processes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quality_processes = await db.quality_processes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of quality_processes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of quality_processes) {
                await record.destroy({transaction});
            }
        });


        return quality_processes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const quality_processes = await db.quality_processes.findByPk(id, options);

        await quality_processes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await quality_processes.destroy({
            transaction
        });

        return quality_processes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const quality_processes = await db.quality_processes.findOne(
            { where },
            { transaction },
        );

        if (!quality_processes) {
            return quality_processes;
        }

        const output = quality_processes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.process_steps_quality_process = await quality_processes.getProcess_steps_quality_process({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.diagram_images = await quality_processes.getDiagram_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



      {
        model: db.file,
        as: 'diagram_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.headline) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quality_processes',
                        'headline',
                        filter.headline,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quality_processes',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.profile_highlight) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quality_processes',
                        'profile_highlight',
                        filter.profile_highlight,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.process_type) {
                where = {
                    ...where,
                process_type: filter.process_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.quality_processes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'quality_processes',
                        'headline',
                        query,
                    ),
                ],
            };
        }

        const records = await db.quality_processes.findAll({
            attributes: [ 'id', 'headline' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['headline', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.headline,
        }));
    }

    
};

